﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Telerik.Web.Design;
using System.ComponentModel.Design;
using System.Web.UI.Design;
using System.Drawing.Design;
using System.ComponentModel;
using System.Web.UI;
using System.Reflection;
using System.Web.Services;

namespace MyNamespace
{
    public class MyDesigner : ControlDesigner
    {
        public override System.ComponentModel.Design.DesignerActionListCollection ActionLists
        {
            get
            {
                DesignerActionListCollection actions = new DesignerActionListCollection();
                
                actions.Add(AdditionalActionList);

                actions.Add(new RadWebControlDesignerActionList(this, Component));

                actions.AddRange(base.ActionLists);

                return actions;
            }
        }

        private MyActionList _myActionList;
        private MyActionList AdditionalActionList
        {
            get
            {
                if (_myActionList == null)
                {
                    _myActionList = new MyActionList(this);
                }

                return _myActionList;
            }
        }
    }

    public class MyActionList : DesignerActionList
    {
        public MyActionList(ControlDesigner designer)
            : base(designer.Component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection collection = new DesignerActionItemCollection();

            collection.Add(new DesignerActionPropertyItem("MyProperty", "MyProperty:", "", ""));
            collection.Add(new DesignerActionPropertyItem("Text", "Text:", "", ""));
            collection.Add(new DesignerActionPropertyItem("EmptyMessage", "Empty Message:", "", ""));

            return collection;
        }


        string _myProperty = String.Empty;
        public virtual string MyProperty
        {
            get
            {
                return _myProperty;
            }
            set
            {
                _myProperty = value;
                ControlDesigner.InvokeTransactedChange(base.Component, new TransactedChangeCallback(MyPropertyCallback), value, "");
            }
        }

        protected bool MyPropertyCallback(object context)
        {
            TypeDescriptor.GetProperties(typeof(MyInput))["MyProperty"].SetValue(base.Component, (string)context);
            return true;
        }

        string _text = String.Empty;
        public virtual string Text
        {
            get
            {
                return _text;
            }
            set
            {
                _text = value;
                ControlDesigner.InvokeTransactedChange(base.Component, new TransactedChangeCallback(TextCallback), value, "");
            }
        }

        protected bool TextCallback(object context)
        {
            TypeDescriptor.GetProperties(typeof(MyInput))["Text"].SetValue(base.Component, (string)context);
            return true;
        }

        string _emptyMessage = String.Empty;
        public virtual string EmptyMessage
        {
            get
            {
                return _emptyMessage;
            }
            set
            {
                _emptyMessage = value;
                ControlDesigner.InvokeTransactedChange(base.Component, new TransactedChangeCallback(EmptyMessageCallback), value, "");
            }
        }

        protected bool EmptyMessageCallback(object context)
        {
            TypeDescriptor.GetProperties(typeof(MyInput))["EmptyMessage"].SetValue(base.Component, (string)context);
            return true;
        }
    }
}